(************************************************************************
*    This File is Part of the AHM Triton Tools                          *
*    for Borland Delphi and C++ Builder.                                *
*************************************************************************
* Copyright  1995-2000 Alexander H. Mehlhorn (AHM) and Tritontools.com *
* All Rights reserved.                                                  *
*                                                                       *
*    For more Information contact us at                                 *
*    E-Mail : support@tritontools.com                                   *
*    URL : http://www.tritontools.com                                   *
*                                                                       *
*    AHM is copyright by Alexander H. Mehlhorn                          *
*    All Parts of this Collection were developed,                       *
*    designed and implemented by AHM                                    *
*                                                                       *
*    Under no Circumstances may you distribute this file                *
*    in this or any other format. This File is supplied                 *
*    as Evaluation of Source only. No Delphi Components may be developed*
*    using extracts or subsets of this code without expressed permission*
*    by AHM.                                                            *
*                                                                       *
*************************************************************************)
unit AHMTClock;

interface

uses
  SysUtils, Windows, Controls,dialogs,AHMFreeware,
  StdCtrls, Classes, Graphics, Menus,Extctrls;

type
  TAHMDateTime = (dtTime,dtDate);
  TAHMClock = class(TCustomPanel)
  private
    FAbout : TAHMAboutFreeStr;
    o1,o2,o3,d1,d2,d3 : string;
    ftim : TTimer;
    fdtype : TAHMDateTime;
    otime : TDateTime;
    fstyle,fexstyle : Integer;
    fcol : TColor;
    ffloat : boolean;
    fcdig,fcshad : TColor;
    Procedure Setdtype(value : TAHMDateTime);
    procedure Setfloat(value : boolean);
    procedure Setclock(Sender : TObject);
    procedure Setcol(value : TColor);
    procedure SetCDig(value : TColor);
    procedure SetCShad(value : TColor);
  protected
    procedure Paint; override;
    procedure Click; override;
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Loaded; override;
  published
    Property About : TAHMAboutFreeStr read FAbout write FAbout;
    property BackColor : TColor read fcol write Setcol default clSilver;
    property DialogFrame : Boolean read ffloat write setfloat default false;
    property DisplayType : TAHMDateTime read fdtype write Setdtype;
    property DigitColor : TColor read fcdig write SetcDig default clBlack;
    property DigitShadowColor : TColor read fcShad write SetcShad default clGray;
    property DragCursor;
    property DragMode;
    property Enabled;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

implementation

Procedure AHMDrawDigital(Canvas:TCanvas;X1,Y1,zahl :integer;ActColor,Shadow : TColor);
VAR
 ZAHLSTRING : STRING;
 NENNJUMP   : INTEGER;
 NENNCOUNT  : INTEGER;
 ZAHLHELP   : INTEGER;
 ZAHL2 : INTEGER;
ProCEDURE ZEICHNEZAHL(X,Y,AZ,BZ,CZ,DZ,EZ,FZ,GZ:INTEGER);
Procedure Lineit(x1,y1,x2,y2:integer);
begin
  Canvas.Moveto(x1,y1);
  Canvas.Lineto(x2,y2);
end;
BEGIN
  Canvas.Pen.Color:=ActColor;
  IF AZ=1 THEN  LINEit(X-1,Y+1,X-1,Y+3);
  IF BZ=1 THEN  LINEit(X-1,Y+5,X-1,Y+7);
  IF CZ=1 THEN  LINEit(X+1,Y,X+3,Y);
  IF DZ=1 THEN  LINEit(X+1,Y+8,X+3,Y+8);
  IF EZ=1 THEN  LINEit(X+5,Y+1,X+5,Y+3);
  IF FZ=1 THEN  LINEit(X+5,Y+5,X+5,Y+7);
  IF GZ=1 THEN  LINEit(X+1,Y+4,X+3,Y+4);
  Canvas.Pen.Color:=Shadow;
  IF AZ=1 THEN  LINEit(X,Y,X,Y+2);
  IF BZ=1 THEN  LINEit(X,Y+4,X,Y+6);
  IF CZ=1 THEN  LINEit(X+2,Y-1,X+4,Y-1);
  IF DZ=1 THEN  LINEit(X+2,Y+7,X+4,Y+7);
  IF EZ=1 THEN  LINEit(X+6,Y,X+6,Y+2);
  IF FZ=1 THEN  LINEit(X+6,Y+4,X+6,Y+6);
  IF GZ=1 THEN  LINEit(X+2,Y+3,X+4,Y+3);
END;
ProCEDURE VERSTEHEZAHL(ZAHL1,X,Y: INTEGER);
BEGIN
IF  ZAHL1=1 THEN ZEICHNEZAHL(X,Y,0,0,0,0,1,1,0);
IF  ZAHL1=2 THEN ZEICHNEZAHL(X,Y,0,1,1,1,1,0,1);
IF  ZAHL1=3 THEN ZEICHNEZAHL(X,Y,0,0,1,1,1,1,1);
IF  ZAHL1=4 THEN ZEICHNEZAHL(X,Y,1,0,0,0,1,1,1);
IF  ZAHL1=5 THEN ZEICHNEZAHL(X,Y,1,0,1,1,0,1,1);
IF  ZAHL1=6 THEN ZEICHNEZAHL(X,Y,1,1,1,1,0,1,1);
IF  ZAHL1=7 THEN ZEICHNEZAHL(X,Y,0,0,1,0,1,1,0);
IF  ZAHL1=8 THEN ZEICHNEZAHL(X,Y,1,1,1,1,1,1,1);
IF  ZAHL1=9 THEN ZEICHNEZAHL(X,Y,1,0,1,1,1,1,1);
IF  ZAHL1=0 THEN ZEICHNEZAHL(X,Y,1,1,1,1,1,1,0);
END;
BEGIN
  NENNJUMP:=0;
  NENNCOUNT:=1;
  IF ZAHL>9 THEN NENNCOUNT:=2;
  IF ZAHL>99 THEN NENNCOUNT:=3;
  IF ZAHL>999 THEN NENNCOUNT:=4;
  IF ZAHL>9999 THEN NENNCOUNT:=5;
  IF ZAHL>99999 THEN NENNCOUNT:=6;
  IF ZAHL>999999 THEN NENNCOUNT:=7;
  IF ZAHL>9999999 THEN NENNCOUNT:=8;
  IF ZAHL>99999999 THEN NENNCOUNT:=9;
  IF ZAHL>999999999 THEN NENNCOUNT:=10;
  ZAHLSTRING := INTTOSTR(ZAHL);
  FOR ZAHLHELP:=1 TO NENNCOUNT DO
  BEGIN
    INC(NENNJUMP);
    ZAHL2 := STRTOINT(COPY(ZAHLSTRING,NENNJUMP,1));
    IF (ZAHL<10) AND (Y1=20) THEN
    BEGIN
      VERSTEHEZAHL(0,(X1-9)+NENNJUMP*9,Y1);
      VERSTEHEZAHL(ZAHL2,(X1-1)+NENNJUMP*9,Y1);
    END
    ELSE
    VERSTEHEZAHL(ZAHL2,(X1-9)+NENNJUMP*9,Y1);
   END;
END;


constructor TAHMClock.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ffloat:=false;
  fcdig:=clyellow;
  fcol:=clteal;
  fcshad:=clblack;
  ftim:=TTimer.create(self);
  otime := Time;
  ftim.Interval:=100;
  ftim.OnTimer:=setclock;
  ftim.enabled:=true;
  o1:='99';
  o2:='99';
  o3:='99';
end;

procedure TAHMClock.CreateParams;
begin
  inherited CreateParams(Params);
  if ffloat then
  begin
    with Params do fstyle:=Style or WS_DLGFRAME;
    with Params do fexstyle:=ExStyle;
    Caption:='Clock';
  end else
  begin
    with Params do fstyle:=Style;
    with Params do fexstyle:=ExStyle;
  end;
  with Params do Style := fStyle;
  with Params do ExStyle :=fExStyle;
end;

procedure TAHMClock.Loaded;
begin
  inherited Loaded;
end;

destructor TAHMClock.Destroy;
begin
  ftim.free;
  inherited destroy;
end;

procedure TAHMClock.SetCol(Value: TColor);
begin
  Fcol := Value;
  Invalidate;
end;

procedure TAHMClock.SetCDig(Value: TColor);
begin
  Fcdig := Value;
  Invalidate;
end;

procedure TAHMClock.SetCShad(Value: TColor);
begin
  FcShad := Value;
  Invalidate;
end;

procedure TAHMClock.Setdtype(Value: TAHMDateTime);
begin
  Fdtype := Value;
  Invalidate;
end;

procedure TAHMClock.SetClock(Sender : TObject);
var s1,s2,s3,s0 : word;
    w1,h1 : integer;
procedure setdigits;
begin
  if d1<>o1 then
  begin
    AHMDrawdigital(canvas,w1,h1,strtoint(o1[1]),fcol,fcol);
    AHMDrawdigital(canvas,w1+8,h1,strtoint(o1[2]),fcol,fcol);
    AHMDrawdigital(canvas,w1,h1,strtoint(d1[1]),fcdig,fcshad);
    AHMDrawdigital(canvas,w1+8,h1,strtoint(d1[2]),fcdig,fcshad);
  end;
  if d2<>o2 then
  begin
    AHMDrawdigital(canvas,w1+24,h1,strtoint(o2[1]),fcol,fcol);
    AHMDrawdigital(canvas,w1+32,h1,strtoint(o2[2]),fcol,fcol);
    AHMDrawdigital(canvas,w1+24,h1,strtoint(d2[1]),fcdig,fcshad);
    AHMDrawdigital(canvas,w1+32,h1,strtoint(d2[2]),fcdig,fcshad);
  end;
  if d3<>o3 then
  begin
    AHMDrawdigital(canvas,w1+48,h1,strtoint(o3[1]),fcol,fcol);
    AHMDrawdigital(canvas,w1+56,h1,strtoint(o3[2]),fcol,fcol);
    AHMDrawdigital(canvas,w1+48,h1,strtoint(d3[1]),fcdig,fcshad);
    AHMDrawdigital(canvas,w1+56,h1,strtoint(d3[2]),fcdig,fcshad);
  end;
  o3:=d3; o2:=d2; o1:=d1;
end;
begin
  w1:=round(width/2-32);
  h1:=round(height/2-5);
  if fdtype=dtTime then
  decodetime(time,s1,s2,s3,s0) else
  if fdtype=dtDate then
  decodedate(Date,s3,s2,s1);
  d1:=inttostr(s1);
  if length(d1)<2 then d1:=concat('0',d1);
  d2:=inttostr(s2);
  if (d2='0') or (d2='') then d2:='00';
  if length(d2)<2 then d2:=concat('0',d2);
  d3:=inttostr(s3);
  if fdtype=dtDate then
  if length(d3)=4 then d3:=copy(d3,3,2);
  if (d3='0') or (d3='') then d3:='00';
  if length(d3)<2 then d3:=concat('0',d3);
  setdigits;
end;

procedure TAHMClock.SetFloat(Value: Boolean);
begin
  Ffloat := Value;
  Recreatewnd;
end;

procedure TAHMClock.Click;
begin
  inherited click;
  if Fdtype = dtTime then fdtype:=dtDate
  else fdtype:=dtTime;
  Recreatewnd;
end;

procedure TAHMClock.Paint;
var
  fRect: TRect;
  w1,h1 : integer;
begin
  o1:='99';
  o2:='99';
  o3:='99';
  inherited paint;
  w1:=round(width/2-30);
  h1:=round(height/2-3);
  canvas.brush.color:=fcol;
  canvas.pen.color:=fcol;
  frect := Rect(0,0,width,height);
  canvas.rectangle(frect.left,frect.top,frect.right,frect.bottom);
  canvas.font.name:='MS Sans Serif';
  if fdtype=dtTime then
  begin
    canvas.font.color := fcshad;
    canvas.textout(w1+16,h1-4,TimeSeparator);
    canvas.textout(w1+40,h1-4,TimeSeparator);
    canvas.font.color := fcDig;
    canvas.textout(w1+15,h1-5,TimeSeparator);
    canvas.textout(w1+39,h1-5,TimeSeparator);
  end
  else
  if fdtype=dtDate then
  begin
    canvas.font.color := fcshad;
    canvas.textout(w1+16,h1-4,'-');
    canvas.textout(w1+40,h1-4,'-');
    canvas.font.color := fcDig;
    canvas.textout(w1+15,h1-5,'-');
    canvas.textout(w1+39,h1-5,'-');
  end;
end;

end.

